extern "C" {
#include "_scm.h"
#include "genio.h"
#include "smob.h"
};
#include <support/ClassInfo.h>
#include "gobjects.h"
#include <stdio.h>

int scm_tcl6_gobject;

GObject::~GObject()
{
}

void *
GObject::Data(void)
{
//	SCM_ASSERT(false, ...);
	return 0;
}

size_t
GObject::Size(void)
{
	return 0;
}


SCM
GObject::MakeScm(void)
{
//	fprintf(stderr, "MakeScm\n");
	SCM res;
	SCM_NEWCELL(res);
	SCM_DEFER_INTS;
	SCM_SETCDR(res, this);
	SCM_SETCAR(res, scm_tcl6_gobject);
	SCM_ALLOW_INTS;
	return res;
}		

int
GObject::scm_gen_put(SCM port, scm_print_state *pstate)
{
	scm_gen_puts(scm_regular_string, "#<", port);
	scm_gen_puts(scm_regular_string, class_name(this), port);
	scm_gen_putc(' ', port);
	scm_intprint((int)this, 16, port);	
	scm_gen_putc('>', port);
	return 1;	
}


extern "C" {
static scm_sizet free_gobject(SCM cell)
{
//	fprintf(stderr, "free_gobject %08X\n", cell);
	GObject *obj = (GObject *)SCM_CDR(cell);
	if (! obj) {
		return 0;
	}
	delete obj;
	return 0;
}
}

extern "C" {
static int
print_gobject(SCM exp, SCM port, scm_print_state *pstate)
{
//	fprintf(stderr, "print_gobject %08X\n", exp);
	GObject *obj = (GObject *)SCM_CDR(exp);
	if (! obj) {
		return 1;
	}
	return obj->scm_gen_put(port, pstate);
}
}

#if 0
	CMessage *msg = cast_as(data, CMessage);
	if (msg) {
  		scm_gen_puts(scm_regular_string, "#<BMessage ", port);
  		scm_gen_putc(((char *)&(msg->d.what))[0], port);
  		scm_gen_putc(((char *)&(msg->d.what))[1], port);
  		scm_gen_putc(((char *)&(msg->d.what))[2], port);
  		scm_gen_putc(((char *)&(msg->d.what))[3], port);
  	}
  	else {
		if (is_instance_of(data, "CMessenger")) {
  			scm_gen_puts(scm_regular_string, "#<BMessenger ", port);
		}
		else {
  			scm_gen_puts(scm_regular_string, "#<unknown ", port);
		}		
  		scm_intprint((int)data, 16, port);	
	}	  	
	scm_gen_putc('>', port);
  	return 1;
}
#endif

static scm_smobfuns gobjectsmob = {
	scm_mark0, free_gobject, print_gobject, 0
};

void
scm_init_gobjects (void)
{
	scm_tcl6_gobject = scm_newsmob(&gobjectsmob);
#include "gobjects.x"
}
